sequenceDiagram
autonumber
participant MWSAPI as MWS API
participant SPAPI as SP-API

Note over MWSAPI, SPAPI: https://github.com/amzn/selling-partner-api-docs/discussions/1971
Note over MWSAPI, SPAPI: Reports API (31/7/22)
Note over MWSAPI, SPAPI: https://docs.developer.amazonservices.com/en_US/reports/Reports_Overview.html
Note over MWSAPI, SPAPI: https://developer-docs.amazon.com/sp-api/docs/reports-api-v2021-06-30-reference
MWSAPI-->SPAPI: CancelReportRequests >> cancelReport (does not appear to be used)

MWSAPI->>SPAPI: GetReport >> getReport + getReportDocument
Note left of SPAPI: SPAPI requires a 2 step process, get the report id, and then download it via a URL, may be encrypted
Note left of SPAPI: getReportDocument is a restricted operation when the report type is a 'restricted' one
Note left of SPAPI: See also notes on ManageReportSchedule / UpdateReportAcknowledgements

MWSAPI-->SPAPI: GetReportCount >> ??? (does not appear to be used)
MWSAPI->>SPAPI: GetReportList >> getReports
MWSAPI->>SPAPI: GetReportListByNextToken >> getReports
MWSAPI-->SPAPI: RequestReport >> ??? (does not appear to be used)
MWSAPI-->SPAPI: GetReportRequestCount >> ??? (does not appear to be used)
MWSAPI-->SPAPI: GetReportRequestList >> ??? (does not appear to be used)
MWSAPI-->SPAPI: GetReportRequestListByNextToken >> ??? (does not appear to be used)

MWSAPI->>SPAPI: ManageReportSchedule >> createReportSchedule / cancelReportSchedule
Note left of SPAPI: Schedules a report every '15' minutes currently, reportType:
Note left of SPAPI: MWS = _GET_ORDER_DATA_
Note left of SPAPI: SP-API = GET_ORDER_REPORT_DATA_INVOICING (TBC)

MWSAPI-->SPAPI: GetReportScheduleList >> getReportSchedule (does not appear to be used)
MWSAPI-->SPAPI: GetReportScheduleListByNextToken >> getReportSchedule (does not appear to be used)
MWSAPI-->SPAPI: GetReportScheduleCount >> getReportSchedule (does not appear to be used)
MWSAPI->>SPAPI: UpdateReportAcknowledgements >> ???
Note left of SPAPI: https://github.com/amzn/selling-partner-api-docs/issues/197
Note left of SPAPI: !!! No equivalent, need to track report ids already processed our end !!!

Note over MWSAPI, SPAPI: Feeds API (31/12/22)
Note over MWSAPI, SPAPI: https://docs.developer.amazonservices.com/en_US/feeds/Feeds_Overview.html
Note over MWSAPI, SPAPI: https://developer-docs.amazon.com/sp-api/docs/feeds-api-v2021-06-30-reference
MWSAPI->>SPAPI: SubmitFeed
MWSAPI->>SPAPI: GetFeedSubmissionList
MWSAPI->>SPAPI: GetFeedSubmissionListByNextToken
MWSAPI->>SPAPI: GetFeedSubmissionCount
MWSAPI->>SPAPI: CancelFeedSubmissions
MWSAPI->>SPAPI: GetFeedSubmissionResult
MWSAPI->>SPAPI: GetLowestOfferListingsForASIN

Note over MWSAPI, SPAPI: Orders API (31/7/22)
Note over MWSAPI, SPAPI: https://docs.developer.amazonservices.com/en_US/orders-2013-09-01/Orders_Overview.html
Note over MWSAPI, SPAPI: https://developer-docs.amazon.com/sp-api/docs/orders-api-v0-reference
MWSAPI-->SPAPI: GetServiceStatus >> ??? (does not appear to be used)

Note over MWSAPI, SPAPI: Products API (Catalogs API) (30/9/22)
Note over MWSAPI, SPAPI: https://docs.developer.amazonservices.com/en_US/products/Products_Overview.html
Note over MWSAPI, SPAPI: https://developer-docs.amazon.com/sp-api/docs/catalog-items-api-v0-reference
MWSAPI->>SPAPI: ListMatchingProducts
MWSAPI->>SPAPI: GetMatchingProduct
MWSAPI->>SPAPI: GetMatchingProductForId