#==============================================================================
# package      DE_EPAGES::PayPalExpress::UI::BasketOrder
# state        private
#==============================================================================
package DE_EPAGES::PayPalExpress::UI::BasketOrder;
use base DE_EPAGES::Presentation::UI::Object;

use strict;
use DE_EPAGES::Order::API::Object::BasketOrderProcess;

#==============================================================================
sub ViewMultiPaymentPayPalExpress {
    my $self = shift;
    my ($Servlet) = @_;
    my $BasketOrder = $Servlet->object;

    my $pli = $BasketOrder->container->get('Payment');
    return unless (defined($pli) && $pli->instanceOf('LineItemPaymentPayPalExpress'));

    # start standard paypal payment
    my $redirectUrl = $pli->checkoutRequest($Servlet, 0);
    $Servlet->vars('PayPalExpressRedirectUrl', $redirectUrl);

    my $BasketOrderProcess = DE_EPAGES::Order::API::Object::BasketOrderProcess->new($Servlet);
    $Servlet->vars('BasketOrderProcess', $BasketOrderProcess->tleHash);

    return;
}

sub ViewPayPalExpressFailed {
    my $self = shift;
    my ($Servlet) = @_;

    my $BasketOrder = $Servlet->object;
    my $Shop = $BasketOrder->get('Shop');

    if ($Shop->isUnity()) {
        my $LineItemPayment = $BasketOrder->container()->get('Payment');
        $LineItemPayment->set({'PaymentErrorCode' => 'Failed'});
        $Servlet->vars('ViewObjectID', $BasketOrder->id());
        $Servlet->vars('ViewAction', 'ViewMultiCheckoutCustomerOrder');
    }
}

1;

